
;  ;
;               *****	   CHATING	*****	  	 ;
;  ;
; 						   	 ;
;  File Name	:	ChatLCD.ASM			 ;
;  Include File:	ENG_I2C.INC			 ;
; 			KEYMATIC.INC			 ;
; 			DLCDPPI.ASM			 ;
;  Date	:	15/04/2004			 ;
;  Moduls	:	2 Unit DT-51 Minsys		 ;	
; 			2 Unit de KITS SPC Keymatic	 ;
;  Components	:	2 Unit Character LCD		 ;
; 			2 Unit Keyboard PS/2		 ;
; 			2 Unit Kabel pita 16pin		 ;
; 			2 Unit Kabel supply 5V Keymatic	 ;
; 			Kabel untuk LCD PPI		 ;
;  ;

$MOD51

		CSEG
		ORG	4000H
		LJMP	START

		ORG	4023H
		LJMP	DATAIN

		ORG	4100H
		$INCLUDE(ENG_I2C.INC)
		$INCLUDE(KEYMATIC.INC)
		$INCLUDE(DLCDPPI.ASM)

;Penerimaan data
DATAIN:		PUSH	ACC
		
		JNB	RI,$				; 1=penerimaan secara serial
		MOV	A,SBUF				; data yg diterima 
		CLR	RI
		PUSH	ACC
		CJNE	R0,#10H,typebar1
		MOV	R0,#0FH

;Prosedur pembersihan baris1 setelah data sudah 16 char
delbaris1:	MOV	A,R0
		LCALL	setddram			
		MOV	A,#20H				
		LCALL	writelcd
		DEC	R0				 
		CJNE	R0,#00H,delbaris1		

typebar1:	MOV	A,R0				; penanda peletakkan karakter yg ditulis pada baris 1
		LCALL	setddram			; dari r0 yg dipindah ke ACC sbg penanda peletakkan karakter
		POP	ACC
		LCALL	writelcd
		INC	R0
		
		POP	ACC
		RETI
		

START:		MOV	SP,#50H
		
		MOV	TMOD,#20H			; Timer/Counter, 8 bit Auto Reload M1=1
		MOV	TL1,#0FDH	
		MOV	TH1,#0FDH
		MOV	PCON,#80H			; Baud Rate = 19200 bps
		MOV	TCON,#40H
		MOV	SCON,#50H
		MOV	IE,#90H
		
		LCALL	INITLCD
		
		mov	R0,#00H				; meletakkan cursor pertama lcd di baris 1
		mov	R1,#40H				; meletakkan cursor pertama lcd di baris 2 

;Program Utama		
		MOV	ADDRESSI2C,#11101110B
		MOV	K8_MODE,#02H
		ACALL	K8_SETMODE
		
LOOP:		JB	k8_int,$
		ACALL	k8_getdata
		
		MOV	A,k8_data
		CJNE	A,#15H,terima  			; 15h (ESC) membersihkan baris 2
		MOV	R1,#4FH				; diisi sesuai batas lcd u/ clear all char pd baris2 kalau tidak 
							; diisi yg dihapus hanya sebatas penulisan terakhir
;Prosedur pembersihan baris 2 setelah data 16 char	
delbaris2:	MOV	A,R1				; dipindahkan ke ACC supaya dapat diletakkan pd alamat ddram
		LCALL	setddram			; r1 rg dipindahkan ke ACC ditulis pd ddram
		MOV	A,#20H				; spasi untuk membersihkan baris 2 (penerjemah ESC)
		LCALL	writelcd
		DEC	R1				 
		CJNE	R1,#39H,delbaris2		; dari dec r1 apakah sudah 39h (batas alamat lcd baris 2)
		MOV	R1,#40H
		MOV	A, k8_data
		CJNE	A,#15H,terima
		AJMP	loop

;Prosedur penghitung R1 sebagai penentu peletakan data pada alamat DDRAM LCD
terima:		CJNE	r1,#50H,typebar2		; batas penulisan u/ 16 char
		AJMP	delbaris2			; pada batas akhir penulisan jika masih ada penulisan lagi maka 
							; penulisan pada satu baris yg pertama akan dihapus demikian seterusnya		
typebar2:	MOV	A,R1
		LCALL	setddram
		MOV	a,k8_data
		LCALL	writelcd
		
		CLR	ES				; interupt kom serial OFF
		MOV	SBUF,A
		JNB	TI,$				; 1=pengiriman secara serial
		CLR	TI
		SETB	ES				; interupt kom serial ON
		INC	R1				;
		
		AJMP	loop
		END